
class TMSSException(Exception):
    pass

class SchemaValidationException(TMSSException):
    pass

class ConversionException(TMSSException):
    pass

class BlueprintCreationException(ConversionException):
    pass

class SubtaskCreationException(ConversionException):
    pass

class SubtaskException(TMSSException):
    pass

class SubtaskIllegalStateTransitionException(SubtaskException):
    pass

class SubtaskInvalidStateException(TMSSException):
    pass

class SchedulingException(TMSSException):
    pass

class SubtaskSchedulingException(SubtaskException, SchedulingException):
    pass

class SubtaskSchedulingSpecificationException(SubtaskSchedulingException):
    pass

class SubtaskSchedulingPermissionException(SubtaskSchedulingException):
    pass

class TaskSchedulingException(SchedulingException):
    pass

class TaskOverlappingWarning(Warning):   # TODO: Create TaskException and switch to Exception by extending from the former when handling overlappings.
    '''raised when there are at least two tasks overlapping.'''
    pass

class DynamicSchedulingException(SchedulingException):
    pass

class SubtaskCancellingException(SubtaskException):
    pass

class UnknownTemplateException(TMSSException):
    '''raised when TMSS trying to base its processing routines on the chosen template, but this specific template is unknown.'''
    pass

class InvalidSpecificationException(TMSSException):
    '''raised when the user submits an invalid specification'''
    pass