# Generated by Django 3.0.9 on 2021-10-07 09:17

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0002_populate'),
    ]

    operations = [
        migrations.AddField(
            model_name='taskblueprint',
            name='short_description',
            field=models.CharField(blank=True, default='', help_text='A short description of this task, usually the name of the target and abbreviated task type.', max_length=32),
        ),
        migrations.AddField(
            model_name='taskdraft',
            name='short_description',
            field=models.CharField(blank=True, default='', help_text='A short description of this task, usually the name of the target and abbreviated task type.', max_length=32),
        ),
        migrations.AlterField(
            model_name='project',
            name='project_state',
            field=models.ForeignKey(default='opened', help_text='The state this project is in.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ProjectState'),
        ),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_task_blueprint_immutable_fields_update()
                      RETURNS trigger AS
                      $BODY$
                      BEGIN
                        IF OLD.specifications_doc <> NEW.specifications_doc OR
                           OLD.name <> NEW.name OR
                           OLD.description <> NEW.description OR
                           OLD.short_description <> NEW.short_description OR
                           OLD.specifications_template_id <> NEW.specifications_template_id OR
                           OLD.scheduling_unit_blueprint_id <> NEW.scheduling_unit_blueprint_id THEN
                          RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE BLUEPRINT FIELD';
                        END IF;
                      RETURN NEW;
                      END;
                      $BODY$
                      LANGUAGE plpgsql VOLATILE;
                      DROP TRIGGER IF EXISTS tmssapp_block_task_blueprint_immutable_fields_update ON tmssapp_TaskBlueprint ;
                      CREATE TRIGGER tmssapp_block_task_blueprint_immutable_fields_update
                      BEFORE UPDATE ON tmssapp_TaskBlueprint
                      FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_task_blueprint_immutable_fields_update();
                      ''')
    ]
