# Generated by Django 3.0.9 on 2021-10-15 07:51

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0003_taskblueprint_shortdescription'),
    ]

    operations = [
        migrations.AddField(
            model_name='subtask',
            name='error_reason',
            field=models.CharField(help_text='Reason why the Subtask went to error.', max_length=200, null=True),
        ),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_subtask_immutable_fields_update()
                          RETURNS trigger AS
                          $BODY$
                          BEGIN
                            IF TG_OP = 'UPDATE' THEN
                              IF OLD.specifications_doc <> NEW.specifications_doc OR
                                 OLD.primary <> NEW.primary OR
                                 OLD.task_blueprint_id <> NEW.task_blueprint_id OR
                                 OLD.specifications_template_id <> NEW.specifications_template_id OR
                                 OLD.cluster_id <> NEW.cluster_id THEN
                                RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE SUBTASK FIELD';
                              END IF;

                              IF OLD.error_reason <> NEW.error_reason OR (OLD.error_reason IS NULL AND NEW.error_reason IS NOT NULL) THEN
                                IF OLD.error_reason IS NOT NULL THEN
                                  RAISE EXCEPTION 'subtask.error_reason may only be set once';
                                END IF;
                                IF NEW.error_reason IS NOT NULL AND NEW.state_id <> 'error' THEN
                                  RAISE EXCEPTION 'subtask.error_reason may only be set when state==error';
                                END IF;
                              END IF;
                            END IF;

                            IF TG_OP = 'INSERT' THEN
                                IF NEW.error_reason IS NOT NULL AND NEW.state_id <> 'error' THEN
                                  RAISE EXCEPTION 'subtask.error_reason may only be set when state==error';
                                END IF;
                            END IF;
                          RETURN NEW;
                          END;
                          $BODY$
                          LANGUAGE plpgsql VOLATILE;
                          DROP TRIGGER IF EXISTS tmssapp_block_subtask_immutable_fields_update ON tmssapp_Subtask ;
                          CREATE TRIGGER tmssapp_block_subtask_immutable_fields_update
                          BEFORE UPDATE OR INSERT ON tmssapp_Subtask
                          FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_subtask_immutable_fields_update();
                          '''),
    ]
