from lofar.sas.tmss.tmss.tmssapp import models


def get_active_station_reservations_in_timewindow(lower_bound, upper_bound):
    """
    Retrieve a list of all active stations reservations, which are reserved between a timewindow
    """
    lst_active_station_reservations = []
    if upper_bound is not None:
        queryset = models.Reservation.objects.filter(start_time__lt=upper_bound)
    else:
        queryset = models.Reservation.objects.all()

    for res in queryset.filter(stop_time=None).values('specifications_doc'):
        if "stations" in res["specifications_doc"]["resources"]:
            lst_active_station_reservations += res["specifications_doc"]["resources"]["stations"]

    if lower_bound is not None:
        for res in queryset.filter(stop_time__gt=lower_bound).values('specifications_doc'):
            if "stations" in res["specifications_doc"]["resources"]:
                lst_active_station_reservations += res["specifications_doc"]["resources"]["stations"]
    return list(set(lst_active_station_reservations))
