# Create your models here.

from django.db.models import TextField, IntegerField,BooleanField, ForeignKey, CASCADE, Model,NullBooleanField
from viewflow.models import Process, Task
from viewflow.fields import FlowReferenceField
from viewflow.compat import _

from lofar.sas.tmss.tmss.tmssapp.models import SchedulingUnitBlueprint
from lofar.sas.tmss.tmss.tmssapp.models.common import ProjectPropertyMixin

class QAReportingTO(Model, ProjectPropertyMixin):
    operator_report = TextField()
    operator_accept = BooleanField(default=False)
    path_to_project = 'flow_process__su__draft__scheduling_set__project'  # todo: verify

class QAReportingSOS(Model, ProjectPropertyMixin):
    sos_report = TextField()
    quality_within_policy = BooleanField(default=False)
    sos_accept_show_pi = BooleanField(default=False)
    path_to_project = 'flow_process__su__draft__scheduling_set__project'  # todo: verify

class PIVerification(Model, ProjectPropertyMixin):
    pi_report = TextField()
    pi_accept = BooleanField(default=False)
    path_to_project = 'flow_process__su__draft__scheduling_set__project'  # todo: verify

class DecideAcceptance(Model, ProjectPropertyMixin):
    sos_accept_after_pi = BooleanField(default=False)
    path_to_project = 'flow_process__su__draft__scheduling_set__project'  # todo: verify

class UnpinData(Model, ProjectPropertyMixin):
    unpin_data = BooleanField(default=False)
    path_to_project = 'flow_process__su__draft__scheduling_set__project'  # todo: verify

class SchedulingUnitTask(Task, ProjectPropertyMixin):
    path_to_project ='flow_process__su__draft__scheduling_set__project'

class SchedulingUnitProcess(Process, ProjectPropertyMixin):
    su = ForeignKey(SchedulingUnitBlueprint, blank=True, null=True, on_delete=CASCADE)
    qa_reporting_to = ForeignKey(QAReportingTO, blank=True, null=True, related_name='flow_process', on_delete=CASCADE)
    qa_reporting_sos = ForeignKey(QAReportingSOS, blank=True, null=True, related_name='flow_process', on_delete=CASCADE)
    pi_verification = ForeignKey(PIVerification, blank=True, null=True, related_name='flow_process', on_delete=CASCADE)
    decide_acceptance = ForeignKey(DecideAcceptance, blank=True, null=True, related_name='flow_process', on_delete=CASCADE)
    results_accepted = BooleanField(default=None, null=True)
    path_to_project = 'su__draft__scheduling_set__project'
